<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

define('FORUM_SKIP_CSRF_CONFIRM', 1);
define('FORUM_DISABLE_CSRF_CONFIRM', 1);

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/post.php';

if (!isset($lang_quick_post_reply)) {
    if (file_exists(FORUM_ROOT.'extensions/quick_post_reply/lang/'.$forum_user['language'].'/quick_post_reply.php') )
		require FORUM_ROOT.'extensions/quick_post_reply/lang/'.$forum_user['language'].'/quick_post_reply.php';
    else
		require FORUM_ROOT.'extensions/quick_post_reply/lang/English/quick_post_reply.php';
}

$action = isset($_GET['action']) ? $_GET['action'] : null;

if ($action == 'get_post_quote')
{
	$tid = isset($_GET['topic_id']) ? intval($_GET['topic_id']) : 0;
	$qid = isset($_GET['post_id']) ? intval($_GET['post_id']) : 0;
	$quote_type = isset($_GET['type']) ? $_GET['type'] : 'defolt';

	if ($tid > 0 && $qid > 0) 
	{
        if ($quote_type == 'smart' && $forum_config['p_message_bbcode'] == '1')
		{
		    $query = array(
		        'SELECT'	=> 'p.poster, p.poster_id, p.message, p.posted',
		        'FROM'		=> 'posts AS p',
		        'WHERE'		=> 'p.id='.$qid.' AND p.topic_id='.$tid,
			    'LIMIT'     => 1
	        );
	
	        if ($forum_db->field_exists('groups', 'link_color'))
	        {
	            $query['SELECT'] .= ', g.link_color';
	            $query['JOINS'][] = array(
		            'INNER JOIN'	    => 'users AS u',
			        'ON'			=> 'u.id=p.poster_id'
	            );
		        $query['JOINS'][] = array(
		            'INNER JOIN'	    => 'groups AS g',
			        'ON'			=> 'g.g_id=u.group_id'
	            );
	        }

	        ($hook = get_hook('po_qr_get_quote')) ? eval($hook) : null;
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	        $quote_info = $forum_db->fetch_assoc($result);

	        if ($quote_info)
	        {
                ($hook = get_hook('po_modify_quote_info')) ? eval($hook) : null;

	            if (strpos($quote_info['poster'], '[') !== false || strpos($quote_info['poster'], ']') !== false)
	            {
		            if (strpos($quote_info['poster'], '\'') !== false)
			            $quote_info['poster'] = '"'.$quote_info['poster'].'"';
		            else
			            $quote_info['poster'] = '\''.$quote_info['poster'].'\'';
	            }
	            else
	            {
		            $ends = utf8_substr($quote_info['poster'], 0, 1).utf8_substr($quote_info['poster'], -1, 1);

		            if ($ends == '\'\'')
			            $quote_info['poster'] = '"'.$quote_info['poster'].'"';
		            else if ($ends == '""')
			            $quote_info['poster'] = '\''.$quote_info['poster'].'\'';
	            }

	            if (isset($quote_info['link_color']))
		            $quote = '[quote='.$quote_info['poster']. ' post_id='.$qid. ' time='.$quote_info['posted']. ' user_id='.$quote_info['poster_id']. ' color='.$quote_info['link_color'].']'.$quote_info['message'].'[/quote]'."\n";
	            else
		            $quote = '[quote='.$quote_info['poster']. ' post_id='.$qid. ' time='.$quote_info['posted']. ' user_id='.$quote_info['poster_id'].']'.$quote_info['message'].'[/quote]'."\n";
			
			    echo json_encode(array('quote'=>$quote));
                die;
			}	
		}
		else
		{
		    $query = array(
		        'SELECT'	=> 'p.poster, p.message',
		        'FROM'		=> 'posts AS p',
		        'WHERE'		=> 'p.id='.$qid.' AND p.topic_id='.$tid,
			    'LIMIT'     => 1
	        );

	        ($hook = get_hook('po_qr_get_quote')) ? eval($hook) : null;
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	        $quote_info = $forum_db->fetch_assoc($result);

	        if ($quote_info)
	        {
	            ($hook = get_hook('po_modify_quote_info')) ? eval($hook) : null;

	            if ($forum_config['p_message_bbcode'] == '1')
	            {
		            if (strpos($quote_info['poster'], '[') !== false || strpos($quote_info['poster'], ']') !== false)
		            {
			            if (strpos($quote_info['poster'], '\'') !== false)
				            $quote_info['poster'] = '"'.$quote_info['poster'].'"';
			            else
				            $quote_info['poster'] = '\''.$quote_info['poster'].'\'';
		            }
		            else
		            {
			            $ends = utf8_substr($quote_info['poster'], 0, 1).utf8_substr($quote_info['poster'], -1, 1);

			            if ($ends == '\'\'')
				            $quote_info['poster'] = '"'.$quote_info['poster'].'"';
			            else if ($ends == '""')
				            $quote_info['poster'] = '\''.$quote_info['poster'].'\'';
		            }

		            $quote = '[quote='.$quote_info['poster'].']'.$quote_info['message'].'[/quote]'."\n";
	            }
	            else
			    {
		            $quote = '> '.$quote_info['poster'].' '.$lang_common['wrote'].':'."\n\n".'> '.$quote_info['message']."\n";
			    }

			    echo json_encode(array('quote'=>$quote));
                die;
		    }
		}
    }
}
else if ($action == 'get_post_preview')
{
    $topic_id = isset($_GET['topic_id']) ? intval($_GET['topic_id']) : 0;

	if ($topic_id > 0) 
	{
		$errors = array();
        $message = isset($_GET['message']) ? forum_linebreaks(forum_trim($_GET['message'])) : '';
			
		if ($message == '')
		    $errors[] = $lang_post['No message'];
			
	    if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
		    $errors[] = sprintf($lang_post['Too long message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
	    else if ($forum_config['p_message_all_caps'] == '0' && check_is_all_caps($message) && !$forum_page['is_admmod'])
		    $errors[] = $lang_post['All caps message'];

	    if ($forum_config['p_message_bbcode'] == '1' || $forum_config['o_make_links'] == '1')
	    {
		    if (!defined('FORUM_PARSER_LOADED'))
			    require FORUM_ROOT.'include/parser.php';

		    $message = preparse_bbcode($message, $errors);
	    }

	    ($hook = get_hook('po_end_validation')) ? eval($hook) : null;
			
	    ob_start();
			
		if (empty($errors))
        {
			if (!defined('FORUM_PARSER_LOADED'))
		        require FORUM_ROOT.'include/parser.php';

	        $preview_message = parse_message(forum_trim($message), 0);
				
			?>
	            <div id="qreply-preview">
					<div class="main-subhead">
		                <h2 class="hn"><span><?php echo $lang_post['Preview reply'] ?></span></h2>
	                </div>
	                <div id="post-preview" class="main-content main-frm">
					    <p class="content-options options">
						    <span class="first-item">
							    <a href="#" class="qreply_close_preview"><?php echo $lang_quick_post_reply['Close'] ?></a>
							</span>
						</p>
		                <div class="post singlepost">
			                <div class="postbody" style="background: #fbfbfb; border-left:0; margin-left:0;">
				                <div class="post-entry">
					                <div class="entry-content">
						                <?php echo $preview_message."\n" ?>
					                </div>
				                </div>
			                </div>
		                </div>
	                </div>
				</div>
            <?php
        }
	    else
	    {
			$preview_errors = array();
		    foreach ($errors as $cur_error)
			    $preview_errors[] = '<li class="warn"><span>'.$cur_error.'</span></li>';

		    ($hook = get_hook('po_pre_post_errors')) ? eval($hook) : null;

            ?>
		        <div class="ct-box error-box reply">
			        <h2 class="warn hn"><?php echo $lang_post['Post errors'] ?></h2>
			        <ul class="error-list">
				        <?php echo implode("\n\t\t\t\t", $preview_errors)."\n" ?>
			        </ul>
		        </div>
            <?php
		}

		$output = ob_get_contents();
	    ob_end_clean();

	    echo json_encode(array('answer'=>((empty($errors)) ? 'preview' : 'error'),'content'=>$output));
        die;
	}
}
else if ($action == 'send_post')
{
    $tid = isset($_POST['topic_id']) ? intval($_POST['topic_id']) : 0;

	if ($tid > 0) 
	{
		$query = array(
//		    'SELECT'	=> 'f.id, f.moderators, t.subject, s.user_id AS is_subscribed',
            'SELECT'	=> 'f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.subject, t.closed, s.user_id AS is_subscribed',
		    'FROM'		=> 'topics AS t',
		    'JOINS'		=> array(
			    array(
				    'INNER JOIN'	=> 'forums AS f',
				    'ON'			=> 'f.id=t.forum_id'
			    ),
			    array(
				    'LEFT JOIN'		=> 'forum_perms AS fp',
				    'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			    ),
			    array(
				    'LEFT JOIN'		=> 'subscriptions AS s',
				    'ON'			=> '(t.id=s.topic_id AND s.user_id='.$forum_user['id'].')'
			    )
		    ),
		    'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.id='.$tid
	    );

	    ($hook = get_hook('po_qr_get_topic_forum_info')) ? eval($hook) : null;
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
        $cur_posting = $forum_db->fetch_assoc($result);
			
	    if ($cur_posting)
		{
			$mods_array = ($cur_posting['moderators'] != '') ? unserialize($cur_posting['moderators']) : array();
            $forum_page['is_admmod'] = ($forum_user['g_id'] == FORUM_ADMIN || ($forum_user['g_moderator'] == '1' && array_key_exists($forum_user['username'], $mods_array))) ? true : false;
		
		    $errors = array();
		
		    if ($forum_user['last_post'] != '' && (time() - $forum_user['last_post']) < $forum_user['g_post_flood'] && (time() - $forum_user['last_post']) >= 0)
		        $errors[] = sprintf($lang_post['Flood'], $forum_user['g_post_flood']);
		
            $message = isset($_POST['message']) ? forum_linebreaks(forum_trim($_POST['message'])) : '';
			
		    if ($message == '')
		        $errors[] = $lang_post['No message'];
			
	        if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
		        $errors[] = sprintf($lang_post['Too long message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
	        else if ($forum_config['p_message_all_caps'] == '0' && check_is_all_caps($message) && !$forum_page['is_admmod'])
		        $errors[] = $lang_post['All caps message'];

	        if ($forum_config['p_message_bbcode'] == '1' || $forum_config['o_make_links'] == '1')
	        {
		        if (!defined('FORUM_PARSER_LOADED'))
			        require FORUM_ROOT.'include/parser.php';

		        $message = preparse_bbcode($message, $errors);
	        }

	        ($hook = get_hook('po_end_validation')) ? eval($hook) : null;

		    if (empty($errors))
            {
				($hook = get_hook('po_form_submitted')) ? eval($hook) : null;
				
				$username = $forum_user['username'];
				$email = $forum_user['email'];
				$now = time();
				$is_subscribed = $tid && $cur_posting['is_subscribed'];
			
			    $post_info = array(
				    'is_guest'		=> $forum_user['is_guest'],
				    'poster'		=> $username,
				    'poster_id'		=> $forum_user['id'],
				    'poster_email'	=> $email,
				    'subject'		=> $cur_posting['subject'],
				    'message'		=> $message,
				    'hide_smilies'	=> 0,
				    'posted'		=> $now,
				    'subscr_action'	=> ($forum_config['o_subscriptions'] == '1' && $is_subscribed) ? 2 : 0,
				    'topic_id'		=> $tid,
				    'forum_id'		=> $cur_posting['id'],
				    'update_user'	=> true,
				    'update_unread'	=> true
			    );

			    ($hook = get_hook('po_pre_add_post')) ? eval($hook) : null;
			    add_post($post_info, $new_pid);
				
				($hook = get_hook('po_pre_redirect')) ? eval($hook) : null;

	            echo json_encode(array('answer'=>'sent',/*'content'=>$lang_quick_post_reply['Message sent']*/'post_id'=>$new_pid));
                die;
            }
	        else
	        {
			    ob_start();
			
			    $preview_errors = array();
		        foreach ($errors as $cur_error)
			        $preview_errors[] = '<li class="warn"><span>'.$cur_error.'</span></li>';

		        ($hook = get_hook('po_pre_post_errors')) ? eval($hook) : null;

               ?>
		            <div class="ct-box error-box reply">
			            <h2 class="warn hn"><?php echo $lang_post['Post errors'] ?></h2>
			            <ul class="error-list">
				            <?php echo implode("\n\t\t\t\t", $preview_errors)."\n" ?>
			            </ul>
		            </div>
                <?php
			
			    $output = ob_get_contents();
	            ob_end_clean();

	            echo json_encode(array('answer'=>'error','content'=>$output));
                die;
		    }
		}
	}
}
if ($action == 'get_edited_post')
{
	$post_id = isset($_GET['post_id']) ? intval($_GET['post_id']) : 0;

	if ($post_id > 0) 
	{
        $query = array(
//	        'SELECT'	=> 'f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.first_post_id, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies',
			'SELECT'	=> 't.first_post_id, p.message',
	        'FROM'		=> 'posts AS p',
	        'JOINS'		=> array(
		        array(
			        'INNER JOIN'	=> 'topics AS t',
			        'ON'			=> 't.id=p.topic_id'
		        ),
		        array(
			        'INNER JOIN'	=> 'forums AS f',
			        'ON'			=> 'f.id=t.forum_id'
		        ),
		        array(
			        'LEFT JOIN'		=> 'forum_perms AS fp',
			        'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
		        )
	        ),
	        'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND p.id='.$post_id
        );

        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
        $cur_post = $forum_db->fetch_assoc($result);

        if ($cur_post)
	    {
			echo json_encode(array('title'=>(($post_id == $cur_post['first_post_id']) ? $lang_post['Edit topic'] : $lang_post['Edit reply']),'message'=>$cur_post['message']));
            die;
		}
    }
}
else if ($action == 'send_edited_post')
{
    $id = isset($_POST['post_id']) ? intval($_POST['post_id']) : 0;

	if ($id > 0) 
	{
		$query = array(
	        'SELECT'	=> 'f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.first_post_id, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies',
//			'SELECT'	=> 'f.moderators, t.closed, p.poster_id',
	        'FROM'		=> 'posts AS p',
	        'JOINS'		=> array(
		        array(
			        'INNER JOIN'	=> 'topics AS t',
			        'ON'			=> 't.id=p.topic_id'
		        ),
		        array(
			        'INNER JOIN'	=> 'forums AS f',
			        'ON'			=> 'f.id=t.forum_id'
		        ),
		        array(
			        'LEFT JOIN'		=> 'forum_perms AS fp',
			        'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
		        )
	        ),
	        'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND p.id='.$id
        );

        ($hook = get_hook('ed_qr_get_post_info')) ? eval($hook) : null;
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
        $cur_post = $forum_db->fetch_assoc($result);

        if ($cur_post)
	    {
		    $mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
            $forum_page['is_admmod'] = ($forum_user['g_id'] == FORUM_ADMIN || ($forum_user['g_moderator'] == '1' && array_key_exists($forum_user['username'], $mods_array))) ? true : false;
		
		    $errors = array();
			
			($hook = get_hook('ed_form_submitted')) ? eval($hook) : null;
			
			if (($forum_user['g_edit_posts'] == '0' || $cur_post['poster_id'] != $forum_user['id'] || $cur_post['closed'] == '1') && !$forum_page['is_admmod'])
	             $errors[] = $lang_common['No permission'];
		
            $message = isset($_POST['message']) ? forum_linebreaks(forum_trim($_POST['message'])) : '';
			
		    if ($message == '')
		        $errors[] = $lang_post['No message'];
			
	        if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
		        $errors[] = sprintf($lang_post['Too long message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
	        else if ($forum_config['p_message_all_caps'] == '0' && check_is_all_caps($message) && !$forum_page['is_admmod'])
		        $errors[] = $lang_post['All caps message'];

	        if ($forum_config['p_message_bbcode'] == '1' || $forum_config['o_make_links'] == '1')
	        {
		        if (!defined('FORUM_PARSER_LOADED'))
			        require FORUM_ROOT.'include/parser.php';

		        $message = preparse_bbcode($message, $errors);
	        }

	        ($hook = get_hook('ed_end_validation')) ? eval($hook) : null;
	
		    if (empty($errors))
            {
			    ($hook = get_hook('ed_pre_post_edited')) ? eval($hook) : null;

		        if (!defined('FORUM_SEARCH_IDX_FUNCTIONS_LOADED'))
			        require FORUM_ROOT.'include/search_idx.php';
			
			    update_search_index('edit', $id, $message);

		        $query = array(
			        'UPDATE'	=> 'posts',
			        'SET'		=> 'message=\''.$forum_db->escape($message).'\', hide_smilies=\'0\'',
			        'WHERE'		=> 'id='.$id
		        );

		        if (!($_POST['silent'] == 1 && $forum_page['is_admmod']))
			        $query['SET'] .= ', edited='.time().', edited_by=\''.$forum_db->escape($forum_user['username']).'\'';

		        ($hook = get_hook('ed_qr_update_post')) ? eval($hook) : null;
		        $forum_db->query_build($query) or error(__FILE__, __LINE__);

		        ($hook = get_hook('ed_pre_redirect')) ? eval($hook) : null;

	            echo json_encode(array('answer'=>'sent',/*'content'=>$lang_quick_post_reply['Message edited']*/'redirect_url'=>forum_link($forum_url['post'], $id)));
                die;
            }
	        else
	        {
			    ob_start();
			
			    $edited_errors = array();
		        foreach ($errors as $cur_error)
			        $edited_errors[] = '<li class="warn"><span>'.$cur_error.'</span></li>';

                ?>
		            <div class="ct-box error-box reply">
			            <h2 class="warn hn"><?php echo $lang_post['Post errors'] ?></h2>
			            <ul class="error-list">
				            <?php echo implode("\n\t\t\t\t", $edited_errors)."\n" ?>
			            </ul>
		            </div>
                <?php
			
			    $output = ob_get_contents();
	            ob_end_clean();

	            echo json_encode(array('answer'=>'error','content'=>$output));
                die;
		    }
		}
	}
}